/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :Tue, Oct 31, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
//#include "typedefine.h"

#include "iodefine.h"
#include "sci.h"


#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

#define Kp 1.0;				//vNR[h12.3

#define r_sen_ref 321	//EZTt@X
#define l_sen_ref 470	//ZTt@X
#define r_wall_ref 53
#define l_wall_ref 46
#define fr_wall_ref 114
#define fl_wall_ref 122


//vOR[h13.10
typedef enum {
	north=0,
	east=1,
	south=2,
	west=3
} t_direction;

//vOR[h13.12
typedef struct{
	unsigned char north:2;
	unsigned char east:2;
	unsigned char south:2;
	unsigned char west:2;
} t_wall;

//vOR[h13.13
#define UNKNOWN 0
#define NOWALL 2
#define WALL 3

//vOR[h13.31
typedef enum {
	front,
	right,
	rear,
	left
} t_local_dir;


//O[oϐ
volatile float v,a;
volatile unsigned int step_l,step_r;		//[^̃pX
volatile short r_sen,l_sen,fr_sen,fl_sen;	//EAOZŤݒl
volatile char attitude_control;				//pRg[
t_direction mydir;							//[J
volatile char	x,y;								//W

t_wall	wall[16][16];						//map
unsigned char map[16][16];					//}bv


//vOR[h6.3
void LED_init(void){
	PORTA.PDR.BIT.B6 = 1;					//porto͂ɐݒ
	PORTB.PDR.BIT.B0 = 1;					//porto͂ɐݒ
	PORTA.PDR.BIT.B4 = 1;					//porto͂ɐݒ
	PORTA.PDR.BIT.B0 = 1;					//porto͂ɐݒ
}

//vOR[h6.3
void _LED(unsigned char data){				//̒lLEDɓ]
	PORTB.PODR.BIT.B0 = data&0x01;
	PORTA.PODR.BIT.B6 = (data>>1)&0x01;
	PORTA.PODR.BIT.B4 = (data>>2)&0x01;
	PORTA.PODR.BIT.B0 = (data>>3)&0x01;
}


//vOR[h8.1
void init_clock(void){
	SYSTEM.PRCR.WORD   = 0xa50b;			//NbN\[XI̕ی̉
	SYSTEM.PLLCR.WORD  = 0x0F00;			// PLL {~16 1 (12.000MHz * 16 = 192MHz)
	SYSTEM.PLLCR2.BYTE = 0x00;				// PLL ENABLE
	SYSTEM.SCKCR.LONG  = 0x21C21211;		//FCK1/4 ICK1/2 BCLK~ SDCLK~ BCK1/4 PCLKA1/2 PCLKB1/4
	SYSTEM.SCKCR2.WORD = 0x0032;			// UCLK1/4 IEBCK1/4
	SYSTEM.BCKCR.BYTE  = 0x01;				// BCLK = 1/2
	SYSTEM.SCKCR3.WORD = 0x0400;			//PLLHI
}

//vOR[h8.2
void CMT0_init(void){ 
	SYSTEM.PRCR.WORD = 0xA502;				//veNg̉
	MSTP(CMT0) = 0;							//CMT0enable
	SYSTEM.PRCR.WORD = 0xA500;
	CMT.CMSTR0.BIT.STR0 = 0;				//CMT0̃JEg~
	CMT0.CMCR.BIT.CKS=1;					//32
	CMT0.CMCR.BIT.CMIE=1;					//荞݋
	CMT0.CMCNT=0;							//JE^[̃NA
	CMT0.CMCOR=375-1;						//0.25ms
	IEN(CMT0,CMI0) = 1;						//荞݋
	IPR(CMT0,CMI0) = 15; 					//荞݂̗D揇
	IR(CMT0,CMI0)=0; 						//
	CMT.CMSTR0.BIT.STR0=1;					//CMT0̃JEgX^[g
}



//vNR[h8.3
void buzzer_init(void){
//I/O̐ݒ
	PORTB.PODR.BIT.B3 = 1;
	PORTB.PDR.BIT.B3 = 1;
	PORTB.PMR.BIT.B3 = 0;
	MPC.PWPR.BIT.B0WI=0;
	MPC.PWPR.BIT.PFSWE=1;
	MPC.PB3PFS.BIT.PSEL=1;
	MPC.PWPR.BYTE=0x80;
//MTU0̐ݒ
	SYSTEM.PRCR.WORD = 0xA502;
	MSTP(MTU) = 0;
	SYSTEM.PRCR.WORD = 0xA500;
	MTU.TSTR.BYTE=0;
	MTU0.TCR.BIT.CCLR=2;
	MTU0.TCR.BIT.TPSC=1;
	MTU0.TMDR.BIT.MD=2;
	MTU0.TIORH.BIT.IOA=5;
	MTU0.TIORH.BIT.IOB=2;
	MTU0.TGRA = (13636 -1);
	MTU0.TGRB = (27272 -1);
	MTU0.TCNT = 0;
}


//vOR[h8.4
void buzzer_on(void){
	MTU0.TCNT = 0;
	PORTB.PMR.BIT.B3 = 1;
	MTU.TSTR.BIT.CST0 = 1;	
}

//vOR[h8,5
void buzzer_off(void){
	PORTB.PMR.BIT.B3 = 0;
	MTU.TSTR.BIT.CST0 = 0;	
}

//vOR[hR[h8.6
void motor_init(void)
{
//I/O̐ݒ
	PORT1.PODR.BIT.B5 = 0;
	PORT1.PDR.BIT.B5 = 1;
	PORTC.PDR.BIT.B5 = 1;
	PORTC.PDR.BIT.B6 = 1;
	MPC.PWPR.BIT.B0WI = 0;
	MPC.PWPR.BIT.PFSWE = 1;
	MPC.P17PFS.BIT.PSEL = 1;
	MPC.PE2PFS.BIT.PSEL = 1;
	MPC.PWPR.BYTE = 0x80;
	PORT1.PMR.BIT.B7 = 1;
	PORTE.PMR.BIT.B2 = 1;
//MTU3,4̐ݒ
	SYSTEM.PRCR.WORD = 0xA502;
	MSTP(MTU) = 0;
	SYSTEM.PRCR.WORD = 0xA500;
	MTU.TSTR.BYTE = 0;
//E[^\pMTUݒ
	MTU3.TCR.BIT.CCLR = 1;
	MTU3.TCR.BIT.TPSC = 2;
	MTU3.TMDR.BIT.MD = 2;
	MTU3.TIORH.BIT.IOA = 2;
	MTU3.TIORH.BIT.IOB = 1;
	MTU3.TGRA = 6297;
	MTU3.TGRB = 50;
	MTU3.TGRC = 6297;
	MTU3.TMDR.BIT.BFA = 1;
	MTU3.TIER.BIT.TGIEB = 1;
	IEN(MTU3,TGIB3) = 1;
	IPR(MTU3,TGIB3) = 13;
	IR(MTU3,TGIB3) = 0;
//[^\pMTUݒ
	MTU.TOER.BIT.OE4A = 1;
	MTU4.TCR.BIT.CCLR = 1;
	MTU4.TCR.BIT.TPSC = 2;
	MTU4.TMDR.BIT.MD = 2;
	MTU4.TIORH.BIT.IOA = 2;
	MTU4.TIORH.BIT.IOB = 1;
	MTU4.TGRA = 6297;
	MTU4.TGRB = 50;
	MTU4.TGRC = 6297;
	MTU4.TMDR.BIT.BFA = 1;
	MTU4.TIER.BIT.TGIEB = 1;
	IEN(MTU4,TGIB4) = 1;
	IPR(MTU4,TGIB4) = 12;
	IR(MTU4,TGIB4) = 0;
	MTU3.TCNT = 0;
	MTU4.TCNT = 0;
}
		

//vOR[h10.1
void SENSOR_init(void)
{
//I/O̐ݒ
	PORT5.PDR.BIT.B4 = 1;
	PORT0.PDR.BIT.B5 = 1;
	PORT2.PDR.BIT.B7 = 1;
	PORTB.PDR.BIT.B5 = 1;
	PORT5.PODR.BIT.B4 = 0;
	PORT0.PODR.BIT.B5 = 0;
	PORT2.PODR.BIT.B7 = 0;
	PORTB.PODR.BIT.B5 = 0;
	PORTE.PMR.BIT.B1 = 1;
	PORT4.PMR.BIT.B4 = 1;
	PORT4.PMR.BIT.B6 = 1;
	PORT4.PMR.BIT.B2 = 1;
	MPC.PWPR.BIT.B0WI = 0;
	MPC.PWPR.BIT.PFSWE = 1;
	MPC.PE1PFS.BIT.ASEL = 1;
	MPC.P44PFS.BIT.ASEL = 1;
	MPC.P46PFS.BIT.ASEL = 1;
	MPC.P42PFS.BIT.ASEL = 1;
	MPC.PWPR.BYTE = 0x80;
//A/D̐ݒ
	SYSTEM.PRCR.WORD = 0xA502;
	MSTP(S12AD) = 0;
	SYSTEM.PRCR.WORD = 0xA500;
	S12AD.ADCSR.BIT.CKS = 3;
	S12AD.ADCSR.BIT.ADCS = 0;
}
	

//vOR[h11.1
void CMT1_init(void){ 
	SYSTEM.PRCR.WORD = 0xA502;			//veNg̉
	MSTP(CMT1) = 0;						//CMT1enable
	SYSTEM.PRCR.WORD = 0xA500;
	CMT.CMSTR0.BIT.STR1 = 0;			//CMT1̃JEg~
	CMT1.CMCR.BIT.CKS=1;				//32
	CMT1.CMCR.BIT.CMIE=1;				//荞݋
	CMT1.CMCNT=0;						//JE^[̃NA
	CMT1.CMCOR=1500-1;					//1ms
	IEN(CMT1,CMI1) = 1;					//荞݋
	IPR(CMT1,CMI1) = 15; 				//荞݂̗D揇
	IR(CMT1,CMI1)=0; 					//
	CMT.CMSTR0.BIT.STR1=1;				//CMT1̃JEgX^[g
}


//vOR[h11.2
void int_mot_r(void)
{
	step_r++;
}

//vOR[h11.2
void int_mot_l(void)
{
	step_l++;
}

//vNR[h13.9
void int_cmt1(void)
{

	short sen_diff,sen_diff_r,sen_diff_l,scale;
	float control_motor;

	v = a + v;

	if(attitude_control){
		scale=1;
		if( (r_wall_ref + r_sen_ref)/2 < r_sen)//E̕ǂ
		{
			sen_diff_r = r_sen - r_sen_ref;
		}else{
			sen_diff_r = 0;
			scale=2;
		}
		if( (l_wall_ref + l_sen_ref)/2 < l_sen)//̕ǂ
		{
			sen_diff_l = l_sen_ref - l_sen ;
		}else{
			sen_diff_l = 0;
			scale=2;		
		}

		sen_diff = (sen_diff_l + sen_diff_r) * scale;
		control_motor = (float)sen_diff * Kp;
	}else{
		control_motor =0;
	}
	
	MTU3.TGRC = 3000000/( (( v + control_motor) /0.377) );
	MTU4.TGRC = 3000000/( (( v - control_motor) /0.377) );

}



//vOR[h11.5
void rotate_right(void)
{
	int i;
	a=0;

	PORTC.PODR.BIT.B5=1;
	PORTC.PODR.BIT.B6=0;
	PORT1.PODR.BIT.B5=1;

	for(i=0;i<1000;i++);	

	v=180;
	step_l=step_r=0;
	MTU.TSTR.BIT.CST3=1;
	MTU.TSTR.BIT.CST4=1;

	while( (step_l+step_r) < (146*2) );

	MTU.TSTR.BIT.CST3=0;
   	MTU.TSTR.BIT.CST4=0;

	for(i=0;i<1000;i++);
}

//vOR[h11.6
void rotate_left(void)
{
	int i;
	a=0;

	PORTC.PODR.BIT.B5=0;
	PORTC.PODR.BIT.B6=1;
	PORT1.PODR.BIT.B5=1;

	for(i=0;i<1000;i++);	

	v=180;
	step_l=step_r=0;
	MTU.TSTR.BIT.CST3=1;
	MTU.TSTR.BIT.CST4=1;

	while( (step_l+step_r) < (146*2) );

	MTU.TSTR.BIT.CST3=0;
	MTU.TSTR.BIT.CST4=0;
	for(i=0;i<1000;i++);
}

//vOR[h12.2
void int_cmt0(void)
{
	static char state=0;
	short i;

	switch(state)
	{
		case 0:
			PORT0.PODR.BIT.B5 = 1;		//EZTpLEDJn
			for(i = 0; i < 300; i++);	//gWX^܂ő҂
			S12AD.ADANS0.BIT.ANS0=0x0040;	//AN006(ẼZT)
			S12AD.ADCSR.BIT.ADST=1;		//ADϊJn
			while(S12AD.ADCSR.BIT.ADST);	//ADϊI܂ő҂
			PORT0.PODR.BIT.B5 = 0;		//EZTpLED	
			r_sen = S12AD.ADDR6;
			break;
		case 1:
			PORT5.PODR.BIT.B4 = 1;		//ZTpLEDsJn
			for(i = 0; i < 300; i++);	//gWX^܂ő҂
			S12AD.ADANS0.BIT.ANS0=0x0004;	//AN002(̃ZT)
			S12AD.ADCSR.BIT.ADST=1;		//ADϊJn
			while(S12AD.ADCSR.BIT.ADST);	//ADϊI܂ő҂
			PORT5.PODR.BIT.B4 = 0;		//ZTpLED
			l_sen = S12AD.ADDR2;
			break;
		case 2:
			PORTB.PODR.BIT.B5 = 1;		//EOZTpLEDJn
			for(i = 0; i < 300; i++);	//gWX^܂ő҂
			S12AD.ADANS0.BIT.ANS0=0x0200;	//AN009(EÕZT)
			S12AD.ADCSR.BIT.ADST=1;		//ADϊJn
			while(S12AD.ADCSR.BIT.ADST);	//ADϊI܂ő҂
			PORTB.PODR.BIT.B5 = 0;		//EOZTpLED	
			fr_sen = S12AD.ADDR9;
			break;
		case 3:
			PORT2.PODR.BIT.B7 = 1;		//OZTpLEDsJn
			for(i = 0; i < 300; i++);	//gWX^܂ő҂
			S12AD.ADANS0.BIT.ANS0=0x0010;	//AN004(ÕZT)
			S12AD.ADCSR.BIT.ADST=1;		//ADϊJn
			while(S12AD.ADCSR.BIT.ADST);	//ADϊI܂ő҂
			PORT2.PODR.BIT.B7 = 0;		//OZTpLED
			fl_sen = S12AD.ADDR4;
			break;
	}
	state++;
	if(state > 3) state=0;
}


//vOR[h13.1
void rotate180(void)
{
	int i;
	a=0;

	PORTC.PODR.BIT.B5=1;
	PORTC.PODR.BIT.B6=0;
	PORT1.PODR.BIT.B5=1;

	for(i=0;i<1000;i++);	

	v=180;
	step_l=step_r=0;
	MTU.TSTR.BIT.CST3=1;
	MTU.TSTR.BIT.CST4=1;

	while( (step_l+step_r) < (146*4) );

	MTU.TSTR.BIT.CST3=0;
   	MTU.TSTR.BIT.CST4=0;

	for(i=0;i<1000;i++);
}


//vOR[h13.2
void kasoku(float accel)
{
	int i;
	
 	PORTC.PODR.BIT.B5=0;
	PORTC.PODR.BIT.B6=0;
	PORT1.PODR.BIT.B5=1;
	
	for(i=0;i<1000;i++);

	v=180;
	a= accel;
	step_l=step_r=0;
	MTU.TSTR.BIT.CST3=1;
	MTU.TSTR.BIT.CST4=1;

	while( (step_l+step_r) < ((477/2)*2) )
	{
		if (v < 300 ){
			a = accel;
		}else{
			a=0;
		}
	}
	MTU.TSTR.BIT.CST3=0;
	MTU.TSTR.BIT.CST4=0; 
}

//vOR[h13.3
void step(void)
{
	
	v=300;
	a= 0;
	step_l=step_r=0;
	MTU.TSTR.BIT.CST3=1;
	MTU.TSTR.BIT.CST4=1;

	while( (step_l+step_r) < (477*2) );
	MTU.TSTR.BIT.CST3=0;
	MTU.TSTR.BIT.CST4=0; 
}

//vOR[h13.4
void gensoku(float accel)
{
	v=300;
	a= -1 * accel;
	step_l=step_r=0;
	MTU.TSTR.BIT.CST3=1;
	MTU.TSTR.BIT.CST4=1;

	while( (step_l+step_r) < ((477/2)*2) )
	{
		if (v > 180 ){
			a = -1*accel;
		}else{
			a=0;
		}
	}
	MTU.TSTR.BIT.CST3=0;
	MTU.TSTR.BIT.CST4=0; 
}

//vOR[h13.6
void buzzer_wait2(void)
{
	int j;
	buzzer_on();
	for(j=0;j<0xfffff;j++);
	buzzer_off();
}

//vOR[h13.7
void left_search(void)
{
	attitude_control=1;
	kasoku(1);
	while(1){
		if((l_wall_ref + l_sen_ref)/2 > l_sen){//ǂȂ
			attitude_control=1;
			gensoku(1);
			attitude_control=0;
			rotate_left();
			attitude_control=1;
			kasoku(1);
		}else if((fl_wall_ref > fl_sen) || (fr_wall_ref > fr_sen)){//OǂȂ
			attitude_control=1;
			step();
		}else if((r_wall_ref + r_sen_ref)/2 > r_sen){//EǂȂ
			attitude_control=1;
			gensoku(1);
			attitude_control=0;
			rotate_right();
			attitude_control=1;
			kasoku(1);
		}else{
			attitude_control=1;
			gensoku(1);
			attitude_control=0;
			rotate180();
			attitude_control=1;
			kasoku(1);
		}
	}
}

//vOR[h13.8
void view_adc(void)
{
	int i;

	while(1)
	{	
		while(SCI1_SEND_CHECK());
		SCI1_PRINTF("r_sen  is\t%d\r\n",r_sen);		//EZT̒l
		while(SCI1_SEND_CHECK());
		SCI1_PRINTF("fr_sen is\t%d\r\n",fr_sen);	//EOZT̒l
		while(SCI1_SEND_CHECK());
		SCI1_PRINTF("fl_sen is\t%d\r\n",fl_sen);	//OZT̒l
		while(SCI1_SEND_CHECK());
		SCI1_PRINTF("l_sen  is\t%d\r\n",l_sen);		//ZT̒l
		for(i = 0; i < 0xfffff; i++);				//\Ԋuݒ
		
		//ʃNAV[PX
		while(SCI1_SEND_CHECK());
		SCI1_PRINTF("\x1b[2J");		//NAXN[[CLS]
		while(SCI1_SEND_CHECK());
		SCI1_PRINTF("\x1b[0;0H");	//J[\0,0Ɉړ
	}
}

//vOR[h13.18
void wall_set(void){
	char wall_write[4];
	wall_write[mydir]       = ((fl_wall_ref > fl_sen) || (fr_wall_ref > fr_sen)) ? NOWALL: WALL;
	wall_write[(mydir+1)%4] = ((r_wall_ref+ r_sen_ref)/2 > r_sen ) ? NOWALL : WALL ;
	wall_write[(mydir+2)%4] = NOWALL;
	wall_write[(mydir+3)%4] = ((l_wall_ref+ l_sen_ref)/2 > l_sen ) ? NOWALL : WALL;
	wall[x][y].north = wall_write[0];
	wall[x][y].east  = wall_write[1];
	wall[x][y].south = wall_write[2];
	wall[x][y].west  = wall_write[3];
	if(y < 15) wall[x][y+1].south = wall_write[0];
	if(x < 15) wall[x+1][y].west  = wall_write[1];
	if(y > 0 ) wall[x][y-1].north = wall_write[2];
	if(x > 0 ) wall[x-1][y].east  = wall_write[3];
}


//vOR[h13.19
void map_init(void){
	int i,j;
	for(i=0;i<16;i++){
		for(j=0;j<16;j++){
			wall[i][j].north =wall[i][j].east = wall[i][j].south =wall[i][j].west = UNKNOWN;
		}
	}
}


void left_turn(void){
	attitude_control=1;
	gensoku(1);
	attitude_control=0;
	rotate_left();
	attitude_control=1;
	kasoku(1);
}

void right_turn(void){
	attitude_control=1;
	gensoku(1);
	attitude_control=0;
	rotate_right();
	attitude_control=1;
	kasoku(1);
}

void turn180(void){
	attitude_control=1;
	gensoku(1);
	attitude_control=0;
	rotate180();
	attitude_control=1;
	kasoku(1);
}

//vOR[h13.20
void left_search2(void)
{
	
	map_init();
	x=y=0;
	mydir=north;
	
	attitude_control=1;
	kasoku(1);
	
	y=y+1;//W̍XV
	
	wall_set();//ǂ̏Zbg
	
	while( (x!=3) || (y!=3) ){
		switch(mydir){
			case north:
				if(wall[x][y].west==NOWALL){
					left_turn();
					mydir=(t_direction)((mydir+3)%4);
					x=x-1;
				}else if(wall[x][y].north==NOWALL){
					attitude_control=1;
					step();
					y=y+1;
				}else if(wall[x][y].east==NOWALL){
					right_turn();
					mydir=(t_direction)((mydir+1)%4);
					x=x+1;					
				}else{
					turn180();
					mydir=(t_direction)((mydir+2)%4);
					y=y-1;					
				}
				break;
			case east:
				if(wall[x][y].north==NOWALL){
					left_turn();
					mydir=(t_direction)((mydir+3)%4);
					y=y+1;
				}else if(wall[x][y].east==NOWALL){
					attitude_control=1;
					step();
					x=x+1;
				}else if(wall[x][y].south==NOWALL){
					right_turn();
					mydir=(t_direction)((mydir+1)%4);
					y=y-1;					
				}else{
					turn180();
					mydir=(t_direction)((mydir+2)%4);
					x=x-1;					
				}
				break;
			case south:
				if(wall[x][y].east==NOWALL){
					left_turn();
					mydir=(t_direction)((mydir+3)%4);
					x=x+1;
				}else if(wall[x][y].south==NOWALL){
					attitude_control=1;
					step();
					y=y-1;
				}else if(wall[x][y].west==NOWALL){
					right_turn();
					mydir=(t_direction)((mydir+1)%4);
					x=x-1;					
				}else{
					turn180();
					mydir=(t_direction)((mydir+2)%4);
					y=y+1;					
				}
				break;
			case west:
				if(wall[x][y].south==NOWALL){
					left_turn();
					mydir=(t_direction)((mydir+3)%4);
					y=y-1;
				}else if(wall[x][y].west==NOWALL){
					attitude_control=1;
					step();
					x=x-1;
				}else if(wall[x][y].north==NOWALL){
					right_turn();
					mydir=(t_direction)((mydir+1)%4);
					y=y+1;					
				}else{
					turn180();
					mydir=(t_direction)((mydir+2)%4);
					x=x+1;					
				}				
				break;
		}
		wall_set();//ǂ̏Zbg				
	}
	attitude_control=1;
	gensoku(1);
}

//vOR[h13.27
void view_map(void){
	int i,j;
	SCI1_PRINTF("\n\r");
	for(j=15;j>-1;j--){
		for(i=0;i<16;i++){
			while(SCI1_SEND_CHECK());
			SCI1_PRINTF("%d%d%d%d",wall[i][j].west,wall[i][j].south,wall[i][j].east,wall[i][j].north);
		}
		while(SCI1_SEND_CHECK());
		SCI9_PRINTF("\n\r");
	}
}
		


//vOR[h13.28
void init_map(int i, int j){
	int m,n;	
	for(m = 0; m < 16; m++){		//H̑傫[v(xW)
		for(n = 0; n < 16; n++){	//H̑傫[v(yW)
			map[m][n] = 255;	//ׂ255Ŗ߂
		}
	}
	map[i][j]=0;
}

//vNR[h13.28
void make_map(int m, int n)
{
	int i,j;
	unsigned char change_flag;
	
	init_map(m,n);		//}bv255ŏAx,y̍W0ŏ	
	
	do{
		change_flag = 0;
		for(i=0;i<16;i++){
			for(j=0;j<16;j++){
				if(map[i][j]==255)
				{
					continue;
				}
				if((wall[i][j].north) ==NOWALL){
					if(map[i][j+1]==255){
							map[i][j+1] = map[i][j]+1;
							change_flag=1;
					}
				}
				if((wall[i][j].east) ==NOWALL){
					if(map[i+1][j]==255){
							map[i+1][j] = map[i][j]+1;
							change_flag=1;
					}
				}
				if((wall[i][j].south) ==NOWALL){
					if(map[i][j-1]==255){
							map[i][j-1] = map[i][j]+1;
							change_flag=1;
					}
				}
				if((wall[i][j].west) ==NOWALL){
					if(map[i-1][j]==255){
							map[i-1][j] = map[i][j]+1;
							change_flag=1;
					}
				}
			}
		}
	}while(change_flag);
}


//vOR[h13.29
t_direction get_nextdir(int m, int n)
{
	int little=255;
	t_direction next_dir;
	
	make_map(m,n);
	
	if(wall[x][y].north == NOWALL){//k
		if(map[x][y+1] < little){
			little = map[x][y+1];
			next_dir = north;
		}
	}
	if(wall[x][y].east == NOWALL){//
		if(map[x+1][y] < little){
			little = map[x+1][y];
			next_dir = east;
		}
	}
	if(wall[x][y].south == NOWALL){//쑤
		if(map[x][y-1] < little){
			little = map[x][y-1];
			next_dir = south;
		}
	}
	if(wall[x][y].west == NOWALL){//
		if(map[x-1][y] < little){
			little = map[x-1][y];
			next_dir = west;
		}
	}
	
	return next_dir;
}

//vOR[h13.30
void fast_run(void)
{
	t_direction next_dir;
	
	x=y=0;
	mydir=north;
	
	attitude_control=1;
	kasoku(1);
	y++;
	
	while( ( x!=3) || (y!=3) ){
		next_dir = get_nextdir(3,3);
		switch((4 + next_dir - mydir)%4 ) {
			case front://Oi
				attitude_control=1;
				step();
				break;
			case right://EɋȂ
				right_turn();
				break;
			case left://ɋȂ
				left_turn();
				break;
		}
		mydir = next_dir;

		switch (next_dir){
			case north :
				y++;
				break;
			case east :
				x++;
				break;
			case south :
				y--;
				break;
			case west :
				x--;
				break;
		}
	}
	attitude_control=1;
	gensoku(1);
}


//vNR[h13.32
void make_map2(int m, int n)
{
	int i,j;
	unsigned char change_flag;
	
	init_map(m,n);		//}bv255ŏAx,y̍W0ŏ	
	
	do{
		change_flag = 0;
		for(i=0;i<16;i++){
			for(j=0;j<16;j++){
				if(map[i][j]==255)
				{
					continue;
				}
				if( ((wall[i][j].north) ==NOWALL)
				||((wall[i][j].north) == UNKNOWN))
				{
					if(map[i][j+1]==255){
							map[i][j+1] = map[i][j]+1;
							change_flag=1;
					}
				}
				if( ((wall[i][j].east) ==NOWALL)
				|| ((wall[i][j].east) ==UNKNOWN))
				{
					if(map[i+1][j]==255){
							map[i+1][j] = map[i][j]+1;
							change_flag=1;
					}
				}
				if( ((wall[i][j].south) ==NOWALL)
				|| ((wall[i][j].south) ==UNKNOWN))
				{
					if(map[i][j-1]==255){
							map[i][j-1] = map[i][j]+1;
							change_flag=1;
					}
				}
				if( ((wall[i][j].west) ==NOWALL)
				|| ((wall[i][j].west) ==UNKNOWN))
				{
					if(map[i-1][j]==255){
							map[i-1][j] = map[i][j]+1;
							change_flag=1;
					}
				}
			}
		}
	}while(change_flag);
}


//vOR[h13.33
t_direction get_nextdir2(int m, int n)
{
	int little=255;
	t_direction next_dir;
	
	make_map2(m,n);
	
	if(wall[x][y].north == NOWALL){//k
		if(map[x][y+1] < little){
			little = map[x][y+1];
			next_dir = north;
		}
	}
	if(wall[x][y].east == NOWALL){//
		if(map[x+1][y] < little){
			little = map[x+1][y];
			next_dir = east;
		}
	}
	if(wall[x][y].south == NOWALL){//쑤
		if(map[x][y-1] < little){
			little = map[x][y-1];
			next_dir = south;
		}
	}
	if(wall[x][y].west == NOWALL){//
		if(map[x-1][y] < little){
			little = map[x-1][y];
			next_dir = west;
		}
	}
	
	return next_dir;
}


//vOR[h13.34
void search_adachi(void)
{
	t_direction next_dir;
	
	x=y=0;
	mydir=north;
	
	attitude_control=1;
	kasoku(1);
	y++;
	
	wall_set();
	
	while( ( x!=3) || (y!=3) ){
		next_dir = get_nextdir2(3,3);
		switch((4 + next_dir - mydir)%4 ) {
			case front://Oi
				attitude_control=1;
				step();
				break;
			case right://EɋȂ
				right_turn();
				break;
			case left://ɋȂ
				left_turn();
				break;
			case rear:
				turn180();
				break;
		}
		mydir = next_dir;

		switch (next_dir){
			case north :
				y++;
				break;
			case east :
				x++;
				break;
			case south :
				y--;
				break;
			case west :
				x--;
				break;
		}
		wall_set();
	}
	attitude_control=1;
	gensoku(1);
}



//vOR[h13.5
void main(void)
{
	char mode=1;
	
	init_clock();
	LED_init();
	CMT0_init();
	CMT1_init();
	SENSOR_init();
	buzzer_init();
	motor_init();
	SCI1_INIT();
	
	while(1){
		_LED(mode);
		if(!PORTC.PIDR.BIT.B2){
			buzzer_wait2();
			mode++;
			if(mode>15)mode=15;
			while(!PORTC.PIDR.BIT.B2);
			buzzer_wait2();
		}
		if(!PORT3.PIDR.BIT.B1){
			buzzer_wait2();
			mode--;
			if(mode<1)mode=1;
			while(!PORT3.PIDR.BIT.B1);
			buzzer_wait2();
		}
		if(!PORTC.PIDR.BIT.B3){
			buzzer_wait2();
			break;
		}
	}
	switch(mode){
		case 1:
			left_search();
			break;
		case 15:
			view_adc();
			break;
		default:
			break;
	}
	while(1);
}
/*

//vOR[h13.26
void main(void)
{
	
	init_clock();
	SCI1_INIT();
	SCI1_PRINTF("Hello Wolrd\n\r");
	while(1);
}
*/

#ifdef __cplusplus
void abort(void)
{

}
#endif
